
UNIT DMCUT;

INTERFACE

USES DOS
{$IFDEF linux},linux{$ENDIF};


TYPE
  namestring        = {$IFDEF LINUX} STRING {$ELSE} STRING [12] {$ENDIF};
  str20        =  String [20];
  str80        =  STRING [80];
  dirtyp       = ARRAY [0..300] OF NAMESTRING;

VAR
  regs           :  Registers;
  path, next,st  :  String;
  c, c1, c2      :  Char;
  count,first,
  last,diff,
  marked         :  word;
  i, j, max      :  Integer;
  srec           :  searchrec;
  dira           :  dirtyp;
  RedrawFlag            :  Boolean;
  strg,mask      :  namestring;
  HighLite,
  Text,
  Border,
  Background     :  Word;



PROCEDURE InitDir (APath,AMask: String;C1,C2,C3,C4 : Word);
FUNCTION GetDirectory(var Selected : String)  : Boolean;
PROCEDURE _FILL;
IMPLEMENTATION
USES VIDEO,KEYMAKRO,TOOLBOX,SCREEN,IADVAR;


PROCEDURE DIR;
BEGIN
 I := 0;
   {$IFDEF linux}
 FindFirst(path+'*', $20 + $10, srec);
   {$ELSE}
 FindFirst(path+'*.*', $20 + $10, srec);
{$ENDIF}   
  WHILE NOT(DosError = 18) AND (i<=100) DO BEGIN
    IF srec.attr = $10 THEN BEGIN
    IF Srec.name <> '.' THEN BEGIN
      Inc(i);
      Dira[i] := srec.name+PATH_SEP;
    END;
   END;
   FindNext (srec);
  END;
  FindFirst(path+mask, $20, srec);
  While NOT (DosError = 18) AND (i <= 100) DO BEGIN
   Inc (i);
   dira[i] := srec.name;
   FindNext(srec)
  END;
  max := i;
 END;


PROCEDURE _fill;
Var x,y  : Byte;
    cnt  : Byte;
    test:string;
BEGIN
 x := 11;
 y := 10;
 IF RedrawFlag THEN
 BEGIN
  Rahmen(10,9,71,19,1,TRUE,BORDER);
  prints(40-((length(path)+length(mask)) DIV 2)-1,9,' '+path+mask+' ',BORDER);
  RedrawFlag := FALSE;
 END;
 last := max;
 IF last > 0 THEN
 BEGIN
   IF last > 35 + first THEN last := first + 35;
   FOR cnt := first TO last DO
   BEGIN
     IF CNT = marked THEN
     BEGIN
      PrintS(x,y,' ' + dira[cnt]+
             stringD(' ',abs(14 - Length(dira[cnt]))),
             HighLite);
      (* Cursor setzen...*)
{$IFNDEF linux}
	ASM
        MOV ah,2
        MOV bh,0
        MOV dl,x
        MOV dh,y
        INT $10
     END;
{$ENDIF}
     END ELSE
      Prints(x,y,' ' + copy(dira[cnt]+stringD(' ',abs(14 - Length(dira[cnt]))),1,14),text);
     x := x + 15;
     IF x > 60 THEN
     BEGIN
       x := 11;
       Inc(y);
     END;
   END;
 END ELSE
   PrintS(11,10,'No files found.',text);
END;

Function GetDirectory(var Selected : String)  : Boolean;
BEGIN
  GetDirectory:=TRUE;
  Selected := '';
  IF Xkeypressed THEN
  BEGIN
    c1 := XReadKey;
    IF c1 = #0 THEN
    BEGIN
      CASE XREADKEY OF
        'K' :  IF marked > first THEN Dec(marked);
        'M' :  IF (marked < max) AND
                  (marked < 35 + first ) THEN inc(marked);

        'H' : IF (marked > 1) THEN
              BEGIN
                IF (first+4 > marked) THEN
                BEGIN
                  IF (marked > 4) AND (first > 4) THEN
                  BEGIN
                     Dec(first, 4);
                     Dec(marked, 4);
                     RedrawFlag := true;
                     _fill;
                  END;
                END ELSE
                BEGIN
                 IF marked > 3 + first THEN
                   Dec (marked, 4);
                END;
              END;
        'P' : BEGIN
                IF (first+31 < marked) AND
                   (first+36 > marked ) THEN
                BEGIN
                  IF marked+4 <max THEN
                  BEGIN
                    INC(first,4);
                    Inc (marked,4);
                    RedrawFlag := true;
                    _fill;
                  END ELSE
                  BEGIN
                    IF marked <> max THEN
                    BEGIN
                      Inc (first,4); marked := max;
                      RedrawFlag := true;
                      _fill;
                    END;
                  END;
                END ELSE
                BEGIN
                  IF (marked <= max -4) AND
                     (marked <= 31 + first ) THEN
                     Inc (marked,4)
                    ELSE IF marked > max -4 THEN marked := Max;
                END;
              END;
      END;
    END ELSE BEGIN
     CASE c1 OF
        #27 : Selected := '<ESC>';
        #13 : BEGIN
                 IF dira[marked][Length(dira[marked])] = PATH_SEP THEN
                 BEGIN
                   IF dira[marked] <> ':'+PATH_SEP THEN
                   BEGIN
                     IF dira[marked] ='..'+PATH_SEP THEN
                     BEGIN
                       IF (path <> PATH_SEP) AND (path<>'') THEN
                       BEGIN
                         REPEAT
                           DEC(byte(path[0]));
                         UNTIL (path[length(path)] = PATH_SEP);
                       END;
                     END ELSE
                       path := path + dira[marked];
                     RedrawFlag := TRUE; marked := 1; first:=1;
                     dir; _fill;
                   END;
                 END ELSE
                    Selected := path + dira[marked];
              END;
      END;
    END;
    _fill;
     prints(12,19,stringd(' ',(56-length(dira[marked])) DIV 2)+dira[marked]+stringd(' ',(56-length(dira[marked])) DIV 2),text);
  END;
  GetDirectory := (Selected = '');
  IF Selected<>'' THEN
  BEGIN
    {$IFNDEF linux} 
    IF ins_mode THEN Cursor(2) ELSE
      Cursor(1);
    {$ENDIF} 
    ConsoleState:=LastConsoleState;
    Redrawscreen;
  END;
END;


Procedure InitDir (APath,AMask: String;C1,C2,C3,C4 : Word);
BEGIN
{$IFNDEF linux}
   Cursor(0);
{$ENDIF}   
 Text := c1;
 Border := c2;
 Background := c3;
 HighLite := c4;
{$IFDEF linux}
   mask:='*';
   {$ELSE}
 mask := '*.*';
   {$ENDIF}
 marked := 1;
 path:=apath;
 IF path[length(path)]<>PATH_SEP THEN
   path:=path+PATH_SEP;
 IF amask<>'' THEN
  mask:=amask;
 dir;
 RedrawFlag := TRUE;
 first := 1;
 _fill;
END;

END.




