UNIT toolbox;
INTERFACE
USES
{$IFNDEF linux}
win,
{$ENDIF}
dos,crt;

type charset=set of char;
    string2=string[2];
    string12=string[12];

const _zeilen:BYTE=24;
      _spalten:BYTE=80;

{$IFDEF linux}
   PATH_SEP='/';
{$ELSE}
   PATH_SEP='\';
{$ENDIF}

var
{$IFNDEF linux}
    Keyb1:byte absolute $40:$17;
    keyb2:byte absolute $40:$18;
    keyb3:Byte absolute $40:$96;
    _SeriellPort:array[1..4] of byte absolute $40:00;
    _ParalellPort:array[1..4] of byte absolute $40:$08;
    _SystemStatus:Byte absolute $40:$10;
    _InterfaceStatus:byte absolute $40:$10;
    _AltBuffer:byte absolute $40:$19;
    _VideoMode:byte absolute $40:$49;
    _cursorPos:array[0..7] of word absolute $40:$50;
    _BildSeite:byte absolute $40:$62;
    _ModusReg:byte absolute $40:$65;
    _FarbAuswahlReg:byte absolute $40:$66;
    _SysTimer:Longint absolute $40:$6C;
    _TimeOutPar:array[1..4] of byte absolute $40:$78;
    _TimeOutSer:array[1..4] of byte absolute $40:$7C;
    _EGAVGAInfo:byte absolute $40:$87;
    _MonitorTyp:byte absolute $40:$88;
    _VGAInfo:byte absolute $40:$89;
    _FloppyInfo:byte absolute $40:$8F;
    _DiskA:byte absolute $40:$90;
    _DiskB:byte absolute $40:$91;
    _IstEGAVGAda:byte absolute $40:$A8;
    _LetzterZugriffAB:byte absolute $50:$04;
{$ENDIF}
    EddiChange:boolean;
    EddiAnz:integer;
    exacttime:LONGINT;

CONST
  KEY_PGUP=#$49;
  KEY_PGDN=#$51;
  KEY_POS1=#$47;
  KEY_END=#$4f;
  KEY_INS=#$52;
  KEY_DEL=#$53;
  KEY_UP=#$48;
  KEY_DOWN=#$50;
  KEY_LEFT=#$4b;
  KEY_RIGHT=#$4d;
{$IFDEF FPK}
FUNCTION CheckCall(s:STRING):BOOLEAN;
  
FUNCTION FilterCRLF(S:STRING):STRING;
{$ENDIF}  
PROCEDURE SetTZoffs(offs:SHORTINT);
FUNCTION mkTStr(ti:longint):STRING12;
{$IFNDEF linux}
PROCEDURE setvmode(b:byte);
PROCEDURE SelectBlock(a,b:byte);
{$ENDIF}
FUNCTION Xhex(Dec: LONGINT): STRING;
FUNCTION IntDate(Zahl: LONGINT): STRING;
FUNCTION DateInt(Date: STRING): LONGINT;
FUNCTION IntTime(Zahl: LONGINT): STRING;
FUNCTION TimeInt(Date: STRING): LONGINT;
Function MakeTimeStr(hour,min,sec:word):string12;
Function MakeDateStr(day,month,year:word):string12;
Function DTDateStr(time:longint):string12;
Function DTTimeStr(time:longint):string12;
function Hex(b:byte):string2;
{$IFNDEF linux}
Function dready(lw:char):Boolean;
Function MF2:boolean;
Function Alt(reLi:Boolean):Boolean;
Function Ctrl(Reli:boolean):Boolean;
Function Shift(RelI:Boolean):Boolean;
Function Num:boolean;
Function Caps:boolean;
Function Ins:boolean;
Function Scroll:Boolean;
Function NumP:boolean;
Function CapsP:boolean;
Function ScrollP:Boolean;
Function InsP:Boolean;
Function Floppys:byte;
function isB:boolean;
function Is87:boolean;
Function is286:boolean;
function isAT:boolean;
function ramsize:word;
{$ENDIF}
function Gross(s:string):string;
function Klein(s:string):string;
{*
FUNCTION TimeOfDay : LONGINT;
FUNCTION TimeDiff( Timer1, Timer2: LONGINT ) : LONGINT;
FUNCTION TimeOfDayH : LONGINT;
FUNCTION TimeDiffH( Timer1, Timer2: LONGINT ) : LONGINT;
*}
Function LTRIM(AStr: String): String;
Function RTRIM(AStr: String): String;
function calc_ixtime(d,m,y,h,mi,s:byte):LONGINT;
procedure decode_ixtime(ix:LONGINT; var d,m,y,h,min,s:byte);
FUNCTION CurrIxTime:LONGINT;
FUNCTION Fills(s:string;b:byte):STRING;
{$IFNDEF linux}
procedure OpenWindow(X1, Y1, X2, Y2: Byte; T: TitleStr;
  TAttr, FAttr: Byte);

procedure CloseWindow;
Procedure activeWindow(Active:boolean);
{$ENDIF}

PROCEDURE XGotoXY(X,Y:BYTE);


FUNCTION CutSSID(ACall:STRING):STRING;
FUNCTION Unix2Pack(Unix: LONGINT): LONGINT;
FUNCTION Pack2Unix(Pack: LONGINT): LONGINT;
{$IFNDEF linux}
Procedure Cursor(Groesse:Byte);
{$ENDIF}
FUNCTION StringD(Zeichen: CHAR; Anz: WORD): STRING;
FUNCTION OnlyOneSpace(S: STRING): STRING;
FUNCTION FileDa(s:pathstr):BOOLEAN;
PROCEDURE MakeFNClean(VAR S:STRING);

{$IFDEF linux}
CONST foundstring: BOOLEAN = FALSE;
function pred(b:BYTE):BYTE;
function succ(b:BYTE):BYTE;
function find(source:STRING;ch:CHAR;VAR L,R:STRING):BOOLEAN;


PROCEDURE VAL(S:STRING;VAR W:BYTE;VAR err:INTEGER);
PROCEDURE VAL(S:STRING;VAR W:WORD;VAR err:INTEGER);
PROCEDURE VAL(S:STRING;VAR W:LONGINT;VAR err:INTEGER);
PROCEDURE VAL(S:STRING;VAR W:INTEGER;VAR err:INTEGER);

FUNCTION ConvertByteToString(b:byte):STRING;
FUNCTION ConvertHexStringToWord(S : STRING;VAR W:WORD):BOOLEAN;
FUNCTION JoinStr(s1,s2		  : STRING):STRING;
FUNCTION AddCHAR(s1:STRING;C:CHAR):STRING;

PROCEDURE Sound(freq:WORD);
PROCEDURE Nosound;

{$ENDIF}

IMPLEMENTATION
{$IFNDEF FPK}
USES mystring;
{$ENDIF}

CONST
  utcoffset:SHORTINT=0;

{$IFDEF linux}
PROCEDURE Sound(freq : WORD);
BEGIN
END; { Sound }
PROCEDURE Nosound;
BEGIN
END;

function find(source:STRING;ch:CHAR;VAR L,R:STRING):BOOLEAN;
var p,p1:WORD;

BEGIN
  p:=0;
  for p1:=1 to length(source) DO
    IF source[p1]=ch THEN
    BEGIN 
     p:=p1;
     break;
   END;  
{  if (source[1]=ch) AND (length(source)>0) THEN ClrScr;WriteLN('p:',p,
source);}
  if p>0 THEN
  BEGIN
    L:=copy(source,1,p-1);    
    R:=copy(source,p+1,length(source)-p+1);
    {if L='' THEN 
    BEGIN
      clrscr;
      WriteLn(R);
      WriteLN(p);
      Writeln(length(source)-p+2);
      READLN;
    END;  }
    find:=TRUE;
     foundstring:=TRUE;
  END ELSE
  BEGIN
    L:=source;R:='';
    find:=FALSE;
     foundstring:=FALSE;
  END;
END;  
    
function pred(b:BYTE):BYTE;
BEGIN
  dec(b);
  pred:=b;
END;

function succ(b:BYTE):BYTE;
BEGIN
  inc(b);
  succ:=b;
END;  

{$ENDIF}
PROCEDURE SetTZOffs(offs:SHORTINT);
BEGIN
  utcoffset:=offs;
END;

FUNCTION Fills(s:string;b:byte):STRING;
BEGIN
  fillchar(s[length(s)+1],255-Length(s)-1,' ');
  s[0]:=char(b);
  fills:=s;
END;
{$IFNDEF linux}
type

  TitleStrPtr = ^TitleStr;

  WinRecPtr = ^WinRec;
  WinRec = record
    Next: WinRecPtr;
    State: WinState;
    Title: TitleStrPtr;
    TitleAttr, FrameAttr: Byte;
    Buffer: Pointer;
  end;
{$ENDIF}
var
{$IFNDEF linux}
  TopWindow: WinRecPtr;
  WindowCount: Integer;
  done:boolean;
  ch:char;
{$ENDIF}  
 

FUNCTION CurrIxTime:LONGINT;
VAR h,mi,s,y,d,m,dum:WORD;L:LONGINT;
BEGIN
   GetDate(y,m,d,dum);
   GetTime(h,mi,s,dum);
   l:=Calc_IxTime(d,m,y-1900,h,mi,s)+(utcoffset*3600);
   exacttime:=((L AND NOT $FF000000)*100)+dum;
   CurrIXTime:=l;
END;

{ Berechnung der Unix-Zeit (Sekunden ab 1.1.1970). Joachim Schurig, DL8HBS }
{ time_t ist longint                                                       }
TYPE time_t = LONGINT;


const
    ix_ytable   :   array[70..137] of time_t=
                   ( 0,  31536000,  63072000,  94694400, 126230400, 157766400,
             189302400, 220924800, 252460800, 283996800, 315532800, 347155200,
             378691200, 410227200, 441763200, 473385600, 504921600, 536457600,
             567993600, 599616000, 631152000, 662688000, 694224000, 725846400,
             757382400, 788918400, 820454400, 852076800, 883612800, 915148800,
             946684800, 978220800,1009756800,1041292800,1072828800,1104451200,
            1135987200,1167523200,1199059200,1230681600,1262217600,1293753600,
            1325289600,1356912000,1388448000,1419984000,1451520000,1483142400,
            1514678400,1546214400,1577750400,1609372800,1640908800,1672444800,
            1703980800,1735603200,1767139200,1798675200,1830211200,1861833600,
            1893369600,1924905600,1956441600,1988064000,2019600000,2051136000,
            2082672000,2114294400   );

    ix_mtable   :   array[1..12] of time_t=
                            (   0, 2678400, 5097600, 7776000, 10368000,
                                13046400, 15638400, 18316800, 20995200,
                                23587200, 26265600, 28857600   );           


{UNIC-Zeit-Berechnungen von DL8HBS}
function calc_ixtime(d,m,y,h,mi,s:byte):LONGINT;
var erg     :   LONGINT;
begin
    erg := 0;
    if (y >= 80) and (y <= 137) then begin
        if (m >= 1) and (m <= 12) then begin
            erg := ix_ytable[y] + ix_mtable[m]
                    + longint(pred(d)) * 86400
                    + longint(h) * 3600
                    + longint(mi) * 60
                    + longint(s);
            if (m > 2) and ((y and 3 = 0) and (y <> 100)) then
                erg := erg + 86400;
        end;
    end;
    calc_ixtime := erg;
end;

procedure decode_ixtime(ix:LONGINT ;var d,m,y,h,min,s:byte);
var zsum,x    :   time_t;
begin
    if ix >= 0 then begin
        y   := 137;
        while ix_ytable[y] > ix do dec(y);
       x:=ix_ytable[y];
        zsum    := ix - x;
        m       := 12;

        if (ix > 63072000) and ((y and 3 = 0) and (y <> 100)) then
            zsum    := zsum - 86400;
            
        while ix_mtable[m] > zsum do dec(m);
       x:=ix_mtable[m];
       zsum    := zsum - x;
        d       := succ(zsum div 86400);
        
        zsum    := zsum mod 86400;
        
        h       := zsum div 3600;
        min     := (zsum mod 3600) div 60;
        s       := zsum mod 60;



    end

    else begin
        d   := 1;
        m   := 1;
        y   := 70;
        h   := 0;
        min := 0;
        s   := 0;
    end;

end;

{$IFNDEF linux}
{Aus MyString.PAS mit freundlicher Erlaubnis von Gerd, DG8NDY}

FUNCTION  CutSSID(ACall: String): String; Assembler;
          ASM
             PUSH  DS
             CLD
             LDS   SI,ACall
             LODSB                  {AL = Lnge von ACall}
             XOR   AH,AH
             MOV   CX,AX
             JCXZ  @Ende
             MOV   DX,AX            {Lnge des Strings merken}
             LES   DI,@Result
             INC   DI
          @Schleife:
             LODSB                  {Zeichen laden}
             CMP   AL,'-'
             JE    @Weiter
             STOSB
             LOOP  @Schleife
          @Weiter:
             SUB   DX,CX
             XCHG  AX,DX
          @Ende:
             LES   DI,@Result
         STOSB
             POP   DS
          end;
{Aus MyString.PAS mit freundlicher Erlaubnis von Gerd, DG8NDY,
 ca 35x (!) schneller als wiederholter aufruf von delete(s,1,1)}
Function LTRIM(AStr: String): String; Assembler;
         ASM
            PUSH  DS
            CLD                         {Strings aufwrts}
            LDS   SI,AStr
            LES   DI,@Result
            LODSB
            AND   AL,AL                 {Wenn AL = 0 dann Zero gesetzt}
            JNZ   @W1
            STOSB                       {Nullstring zurck}
            JMP   @Ende
         @W1:
            MOV   CL,AL
            XOR   CH,CH                 {CX = Lnge AStr}
         @Schleife:
            LODSB
            CMP   AL,' '
            JNE    @W2
            LOOP  @Schleife
         @W2:
            XCHG  AH,AL                 {AL nach AH retten und CL -> AL abspeichern}
            MOV   Al,CL
            STOSW                       {Neue Lnge in String speichern}
            JCXZ  @Ende
            SHR   CX,1
            REP   MOVSW
            JNC   @Ende
            MOVSB
         @Ende:
            POP   DS
         END;

Function RTRIM(AStr: String): String; Assembler;
         ASM
            PUSH DS
            STD                 {Stringbearbeitung Abwrts}
            LDS  SI,AStr        {DS:SI = Zeiger auf AStr}
            LES  DI,@Result     {ES:DI = Zeiger auf Ergebniss}
            LODSB               {Lnge von AStr in AL}
            INC  SI             {SI wieder auf Anfangswert}
            STOSB               {Lnge vorerst sichern}
            INC  DI             {DI wieder auf Anfangswert}
            XOR  AH,AH          {AX = Lnge}
            ADD  SI,AX          {DS:SI zeigt auf ende vom String}
            XCHG CX,AX          {CX = Lnge}
            JCXZ @ende
         @Schleife:
            LODSB               {Zeichen einladen}
            CMP AL,20h          {Ist Zeichen ein Space???}
            JNE  @Weiter
            LOOP @Schleife

         @Weiter:
            CLD                 {Stringbearbeitung aufwrts}
            LDS  SI,[AStr]
            INC  SI             {DS:SI zeigt auf erstes Zeichen}
            MOV  AX,CX          {AL = Lnge}
            STOSB               {Richtige Lnge in Ergebniss speichern}
            JCXZ @ende
              SHR   CX,1
              REP   MOVSW
              JNC   @Ende
              MOVSB
         @ende:
            POP  DS
         end;

{$ELSE}

function CUTSSID(ACall:STRING):STRING;
BEGIN
 if pos('-',ACall)>0 THEN Acall:=copy(ACall,1,pos('-',Acall)-1);
 cutssid:=Acall;
END;

function rtrim(AStr:STRING):STRING;
BEGIN
 while (Astr[length(Astr)]=' ') and (length(Astr)>0) do
   dec(byte(Astr[0]));
 rtrim:=Astr;
END;

function ltrim(AStr:STRING):STRING;
BEGIN
  while (Astr[1]=' ') and (length(AStr)>0) do
     delete(AStr,1,1);
  ltrim:=Astr;   
END;
{$ENDIF}
 

{$R-}
FUNCTION IntDate(Zahl: LONGINT): STRING;
VAR n: LONGINT;
    i: INTEGER;
    OK, Schaltjahr: BOOLEAN;
    T, M, J: INTEGER;
    ST, SM, SJ: STRING;
BEGIN
  n := 0;
  J := 0;
  M := 1;
  OK := FALSE;
  FOR i := 1 TO 99 DO BEGIN
    Schaltjahr := ((i+1900) MOD 4=0) AND ((i+1900) MOD 100<>0) OR ((i+1900) MOD 400=0);
    IF Schaltjahr THEN n := n + 1;
    n := n + 365;
    IF (n > Zahl) AND NOT OK THEN BEGIN
      J := i - 1;
      n := n - 365;
      IF Schaltjahr THEN n := n - 1;
      Zahl := Zahl - n;
      OK := TRUE;
    END;
  END;
  IF Zahl>31 THEN BEGIN
    M := M + 1;
    Zahl := Zahl - 31;
  END;
  IF Schaltjahr THEN BEGIN
    IF Zahl>29 THEN BEGIN
      M := M + 1;
      Zahl := Zahl - 29;
    END;
  END
  ELSE BEGIN
    IF Zahl>28 THEN BEGIN
      M := M + 1;
      Zahl := Zahl - 28;
    END;
  END;
  IF Zahl>31 THEN BEGIN
    M := M + 1;
    Zahl := Zahl - 31;
  END;
  IF Zahl>30 THEN BEGIN
    M := M + 1;
    Zahl := Zahl - 30;
  END;
  IF Zahl>31 THEN BEGIN
    M := M + 1;
    Zahl := Zahl - 31;
  END;
  IF Zahl>30 THEN BEGIN
    M := M + 1;
    Zahl := Zahl - 30;
  END;
  IF Zahl>31 THEN BEGIN
    M := M + 1;
    Zahl := Zahl - 31;
  END;
  IF Zahl>31 THEN BEGIN
    M := M + 1;
    Zahl := Zahl - 31;
  END;
  IF Zahl>30 THEN BEGIN
    M := M + 1;
    Zahl := Zahl - 30;
  END;
  IF Zahl>31 THEN BEGIN
    M := M + 1;
    Zahl := Zahl - 31;
  END;
  IF Zahl>30 THEN BEGIN
    M := M + 1;
    Zahl := Zahl - 30;
  END;
  IF Zahl>31 THEN BEGIN
    M := M + 1;
    Zahl := Zahl - 31;
  END;
  T := Zahl;

  IF M = 0 THEN BEGIN
    M := 12;
    J := J - 1;
  END;


  IF T = 0 THEN BEGIN
    M := M - 1;
    IF M = 0 THEN BEGIN
      M := 12;
      J := J - 1;
    END;
    IF (M=1) OR (M=3) OR (M=5) OR (M=7) OR (M=8) OR (M=10) OR (M=12) THEN BEGIN
      T := 31;
    END;
    IF (M=4) OR (M=6) OR (M=9) OR (M=11) THEN BEGIN
      T := 30;
    END;
    Schaltjahr := ((J+1900) MOD 4=0) AND ((J+1900) MOD 100<>0) OR ((J+1900) MOD 400=0);
    IF Schaltjahr AND (M=2) THEN T := 29;
    IF NOT Schaltjahr AND (M=2) THEN T := 28;
  END;
  STR(T, ST);
  STR(M, SM);
  STR(J, SJ);
  IF LENGTH(ST)=1 THEN ST := '0' + ST;
  IF LENGTH(SM)=1 THEN SM := '0' + SM;
  IF LENGTH(SJ)=1 THEN SJ := '0' + SJ;
  IntDate := ST + '.' + SM + '.' + SJ;
END;

FUNCTION DateInt(Date: STRING): LONGINT;
VAR n: LONGINT;
    i: INTEGER;
    Schaltjahr: BOOLEAN;
    T, M, J: LONGINT;
    code:integer;

    S_T, S_M, S_J: STRING;
BEGIN
  n := 0;
  VAL(COPY(Date,1,2),T,code);
  VAL(COPY(Date,4,2),M,code);
  VAL(COPY(Date,7,2),J,code);
  FOR i := 1 TO J DO BEGIN
    Schaltjahr := ((i+1900) MOD 4=0) AND ((i+1900) MOD 100<>0) OR ((i+1900) MOD 400=0);
    IF Schaltjahr THEN n := n + 1;
    n := n + 365;
  END;
  n := n + T;

  IF M>1 THEN n := n + 31;
  IF M>2 THEN BEGIN
    Schaltjahr := ((i+1900) MOD 4=0) AND ((i+1900) MOD 100<>0) OR ((i+1900) MOD 400=0);
    IF Schaltjahr THEN n := n + 29
                  ELSE n := n + 28;
  END;
  IF M>3 THEN n := n + 31;
  IF M>4 THEN n := n + 30;
  IF M>5 THEN n := n + 31;
  IF M>6 THEN n := n + 30;
  IF M>7 THEN n := n + 31;
  IF M>8 THEN n := n + 31;
  IF M>9 THEN n := n + 30;
  IF M>10 THEN n := n + 31;
  IF M>11 THEN n := n + 30;
  DateInt := n;
END;


FUNCTION IntTime(Zahl: LONGINT): STRING;
VAR Std,Min: STRING[2];
    S,M: BYTE;
BEGIN
  S := Zahl DIV 60;
  M := Zahl MOD 60;
  STR(S,Std);
  STR(M,Min);
  IF LENGTH(Std)=0 THEN Std := '0' + Std;
  IF LENGTH(Std)=1 THEN Std := '0' + Std;
  IF LENGTH(Min)=0 THEN Min := '0' + Min;
  IF LENGTH(Min)=1 THEN Min := '0' + Min;
  IntTime := Std + ':' + Min;
END;
{$R+}

FUNCTION Unix2Pack(Unix: LONGINT): LONGINT;
VAR DT: DateTime;
    Day,Month,Year,Hour,Min,Sec: BYTE;
    lint: LONGINT;
BEGIN
  decode_ixtime(Unix,day,month,year,hour,min,sec);
  DT.Day := Day;
  DT.Month := Month;
  DT.Year := Year+1900;
  DT.Hour := Hour;
  DT.Min := min;
  DT.Sec := sec;
  PackTime(DT,lint);
  Unix2Pack := lint;
END;



FUNCTION Pack2Unix(Pack: LONGINT): LONGINT;
VAR DT: DateTime;
    Day,Month,Year,Hour,Min,Sec: BYTE;
BEGIN
  UnpackTime(Pack,DT);
  Day := DT.Day;
  Month := DT.Month;
  Year := DT.Year-1900;
  Hour := DT.Hour;
  Min := DT.Min;
  Sec := DT.Sec;

  Pack2Unix := calc_ixtime(day,month,year,hour,min,sec);
END;


FUNCTION TimeInt(Date: STRING): LONGINT;
VAR
code,Std, Min:INTEGER;
BEGIN
  std:=1;min:=2;
  VAL(COPY(Date,1,2),Std,code);
  VAL(COPY(Date,4,2),Min,code);
  if code>0 Then Writeln('buh'); 
  Min := Min + (Std * 60);
  TimeInt := Min;
END;

{$IFNDEF linux}
Function MF2:boolean;                   {erweiterte Tastatur ?}
Begin

   MF2:=(Keyb3 and 16)<>0;

end;
Function Alt(reLi:Boolean):Boolean;
Begin
   
  If Reli Then alt:=(keyb2 and 2)<>0   {Alt Gedrckt?}
  else alt:=(keyb3 and 8)<>0;          {AltGr ?}
end;

Function Ctrl(Reli:boolean):Boolean;
Begin
  If reli Then Ctrl:=(keyb2 and 1)<>0  {Rechts ?}
  else ctrl:=(keyb3 and 4)<>0;         {Links  ?}
end;
Function Shift(RelI:Boolean):Boolean;
Begin
  If Reli Then shift:=(keyb1 and 2)<>0
  else shift:=(keyb1 and 1)<>0;
end;

Function Num:boolean;
Begin                            {Ziffernblock an?}
  Num:=(keyb1 and 32)<>0;
end;
Function Caps:boolean;
Begin
  Caps:=(keyb1 and 64)<>0;    {Grobuchstaben an ?}
end;
Function Ins:boolean;
Begin
  Ins:=(keyb1 and 128)<>0;     {Einfgemodus ?}
end;
Function Scroll:Boolean;
Begin                              {Rollen ?}
  Scroll:=(keyb1 and 16)<>0;
end;


Function NumP:boolean;
Begin
  Nump:=(keyb2 and 32)<>0;
end;
Function CapsP:boolean;
Begin
  Capsp:=(keyb2 and 64)<>0;
end;
Function InsP:boolean;
Begin
  Insp:=(keyb2 and 128)<>0;
end;
Function ScrollP:Boolean;
Begin
  Scrollp:=(keyb2 and 16)<>0;
end;

Function Floppys:byte;
var b:byte;
Begin                      {Wie viele Diskettenlaufwerke ?}
 b:=0;
 IF (_Systemstatus and 1)<>0 then b:=1;
 b:=b+(_systemstatus shr 6);
 floppys:=b;
end;
function isb:boolean;
Begin                       {True = Laufwerk B: vorhanden}
  isb:=(floppys>1);         {False= B: ist Phantomlaufwerk}
end;
Function is87:boolean;
Begin
  is87:=(_SystemStatus and 2)<>0;
end;
Function isAT:boolean;
begin
  isAT:=mem[$F000:$FFFE]=252;
end;
Function RamSize:word;
var w:word;                        {Klappt jetzt!}
Begin
  if isAT Then
  Begin
    Port[$70]:=$15;
    w:=Port[$71];
    Port[$70]:=$16;
    w:=w+Port[$71]*256;
    Ramsize:=w;
  end else
  ramsize:=MemW[$40:$13];
end;

{$ENDIF}
{$IFNDEF linux}
{Prozedur aus MYSTRING.PAS von DG8NDY, ca doppelt so schnell wie ^}
Function Gross(s: String): String; Assembler;
         Asm
            PUSH DS
            CLD                 {Stringbearbeitung aufwrts}
            LDS  SI,[s]      {DS:SI = Zeiger auf s}
            LES  DI,@Result     {ES:DI = Zeiger auf Gross3}
            LODSB               {AL = Lnge von s}
            STOSB               {                   }
            XOR  AH,AH          {AX = Lnge von s}
            XCHG AX,CX          {CX = Lnge von s}
            XOR  DX,DX          {DX = Zhler fr neue Stringlnge}
            JCXZ @ende          {Wenn CX = 0 dann ende}
          @Schleife:
            LODSB               {AL = Zeichen}
            CMP  AL,''         {AL = ???}
            JNE  @1             {Nein, dann weiter}
            MOV  AL,''
            JMP  @Store
          @1:
            CMP  AL,''         {AL = ???}
            JNE  @2             {Nein, dann weiter}
            MOV  AL,''
            JMP  @Store
          @2:
            CMP  AL,''         {AL = ???}
            JNE  @3             {Nein, dann weiter}
            MOV  AL,''
            jmp  @Store
          @3:
            CMP  AL,''         {AL = ???}
            JNE  @4             {Nein, dann weiter}
            MOV  AL,'S'         {AL = S}
            STOSB               {AL -> Result}
            INC  DX             {String wurde um eins lnger}
            CMP  DX,0FFh        {Schon 255 Zeichen???}
            JE   @ende          {Ja, dann ende}
            JMP  @Store
          @4:
            CMP  AL,'a'         {AL < a???}
            JB   @Store         {Ja, dann weiter}
            CMP  AL,'z'         {AL > z???}
            JA   @Store         {Ja, dann weiter}
            SUB  AL,20h         {Nein, dann ASCII(AL) -32}
          @Store:
            STOSB               {AL -> Result}
            INC  DX             {String wurde um eins lnger}
            CMP  DX,0FFh        {Schon 255 Zeichen???}
            JE   @ende          {Ja, dann ende}
            LOOP @Schleife
          @ende:
            LES  DI,@Result     {ES:DI = Zeiger auf @Result}
            XCHG DX,AX          {AL = DL = Stringlnge des neuen Strings}
            STOSB               {Speichern}
            POP  DS
         end;

Function Klein(s: String): String; Assembler;
         Asm
            PUSH DS
            CLD                 {Stringbearbeitung aufwrts}
            LDS  SI,[s]      {DS:SI = Zeiger auf s}
            LES  DI,@Result     {ES:DI = Zeiger auf Gross3}
            LODSB               {AL = Lnge von s}
            STOSB               {                   }
            XOR  AH,AH          {AX = Lnge von s}
            XCHG AX,CX          {CX = Lnge von s}
            XOR  DX,DX          {DX = Zhler fr neue Stringlnge}
            JCXZ @ende          {Wenn CX = 0 dann ende}
          @Schleife:
            LODSB               {AL = Zeichen}
            CMP  AL,''         {AL = ???}
            JNE  @1             {Nein, dann weiter}
            MOV  AL,'a'
            JMP  @Store
          @1:
            CMP  AL,''         {AL = ???}
            JNE  @2             {Nein, dann weiter}
            MOV  AL,''
            JMP  @Store
          @2:
            CMP  AL,''         {AL = ???}
            JNE  @3             {Nein, dann weiter}
            MOV  AL,''
            jmp  @Store
          @3:
            CMP  AL,''         {AL = ???}
            JNE  @4             {Nein, dann weiter}
            MOV  AL,'S'         {AL = S}
            STOSB               {AL -> Result}
            INC  DX             {String wurde um eins lnger}
            CMP  DX,0FFh        {Schon 255 Zeichen???}
            JE   @ende          {Ja, dann ende}
            JMP  @Store
          @4:
            CMP  AL,'A'         {AL < a???}
            JB   @Store         {Ja, dann weiter}
            CMP  AL,'Z'         {AL > z???}
            JA   @Store         {Ja, dann weiter}
            ADD  AL,20h         {Nein, dann ASCII(AL) -32}
          @Store:
            STOSB               {AL -> Result}
            INC  DX             {String wurde um eins lnger}
            CMP  DX,0FFh        {Schon 255 Zeichen???}
            JE   @ende          {Ja, dann ende}
            LOOP @Schleife
          @ende:
            LES  DI,@Result     {ES:DI = Zeiger auf @Result}
            XCHG DX,AX          {AL = DL = Stringlnge des neuen Strings}
            STOSB               {Speichern}
            POP  DS
         end;

{$ELSE}

function gross(s : string):string;
var b,b1 : BYTE; 
BEGIN
   for B:=1 to length(s) do
      if (s[b]<='z') and (s[b]>='a') THEN
      BEGIN
         b1:=byte(s[b]);
	 b1:=b1-32;
	 byte(s[b]):=(b1);
      END;	 
   gross:=s;
END;

function klein(s : string):string;
var b,b1: BYTE;
BEGIN
   for B:=1 to length(s) do
      if (s[b]<='Z') and (s[b]>='A') THEN
      BEGIN
        b1:=byte(s[b]);
	b1:=b1+32;
	s[b]:=char(b1);
      END;	
   klein:=s;
END;
{$ENDIF}
  
function Hex(b:byte):string2;
VAR L : LONGINT;
   s  : STRING[2];
BEGIN
   l:=B;
   
   s:=xhex(l);
   if length(s)=1 THEN hex:='0'+s
   else hex:=s;
END;
{
const table:array[0..$F] of char=('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');

var s:string2;
begin
  s:='00';
  s[1]:=table[b DIV 16];
  s[2]:=table[(b MOD 16)];
  hex:=s;
end;}



{Prozeduren aus Windemo.Pas}
{$IFNDEF linux}
procedure OpenWindow(X1, Y1, X2, Y2: Byte; T: TitleStr;
  TAttr, FAttr: Byte);
var
  W: WinRecPtr;
begin  
  {*
  If Mouseinstalled then HideMouse;
  *}
  New(W);
  with W^ do
  begin
    Next := TopWindow;
    SaveWin(State);
    GetMem(Title, Length(T) + 1);
    Title^ := T;
    TitleAttr := TAttr;
    FrameAttr := FAttr;
    Window(X1, Y1, X2, Y2);
    GetMem(Buffer, WinSize);
    ReadWin(Buffer^);
    FrameWin(T, singleFrame, TATTR, FAttr);
  end;
  TopWindow := W;
  Inc(WindowCount);
  {*
  if Mouseinstalled then Showmouse;
  *}
end;

procedure ActiveWindow(Active: Boolean);
begin
  if TopWindow <> nil then
  begin
    UnFrameWin;
    with TopWindow^ do
      if Active then
        FrameWin(Title^, DoubleFrame, TitleAttr, FrameAttr)
      else
        FrameWin(Title^, SingleFrame, FrameAttr, FrameAttr);
  end;
end;


procedure CloseWindow;
var
  W: WinRecPtr;
begin
  {*
  if mouseinstalled Then HideMouse;
  *}
  if TopWindow <> nil then
  begin
    W := TopWindow;
    with W^ do
    begin
      UnFrameWin;
      WriteWin(Buffer^);
      FreeMem(Buffer, WinSize);
      FreeMem(Title, Length(Title^) + 1);
      RestoreWin(State);
      TopWindow := Next;
    end;
    Dispose(W);
    Dec(WindowCount);
  end;
  {*
  if mouseinstalled then showmouse;
  *}
end;

function dready(lw:char):Boolean;
var sr:searchrec;
begin
  dReady:=false;
  Findfirst('a:\CON',anyfile,sr);
  If doserror<>152 then
  Begin
    dReady:=true;
  end;                   {Laufwerk bereit ?}
end;

{$ENDIF}
FUNCTION Xhex(Dec: LONGINT): STRING;
CONST hexzahl: ARRAY[0..15] OF CHAR =
        ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
{$R-}
VAR Uebertr: BYTE;
Divid: LONGINT;
Hexadec: STRING;
BEGIN
  Hexadec := '';
  Divid := Dec;
  REPEAT
    Uebertr := Divid MOD 16;
    Uebertr := Uebertr AND $0F;
    Divid := Divid DIV 16;
    Hexadec := HexZahl[Uebertr] + Hexadec;
  UNTIL Divid = 0;
  XHex := Hexadec;
END;
{$IFNDEF linux}
{$R+}

function Is286: Boolean; assembler;
asm
        PUSHF
        POP     BX
        AND     BX,0FFFH
        PUSH    BX
        POPF
        PUSHF
        POP     BX
        AND     BX,0F000H
        CMP     BX,0F000H
        MOV     AX,0
        JZ      @@1
        MOV     AX,1
@@1:
end;
{$ENDIF}
Function MakeDaTistr(hour,min,sec:word;trenn:char):string12;
var s1:string[4]; s:string12;
Begin
  str(hour,s1);
  if hour<10 then s1:='0'+s1;
  s:=s1+trenn;
  str(min,s1);
  if min<10 then s1:='0'+s1;
  s:=s+s1+trenn;
  str(sec,s1);
  if sec<10 then s1:='0'+s1;
  s:=s+s1;
  makedatistr:=s;
end;

Function MakeTimeStr(hour,min,sec:word):string12;
Begin
  MakeTimeStr:=MAKEdATiStr(hour,min,sec,':');
end;
Function MakeDateStr(day,month,year:word):string12;
Begin
  MakeDateStr:=MAKEdATiStr(day,month,year,'.');
end;
Function DTTimeStr(time:longint):string12;
var dt:datetime;
begin
  unpacktime(time,dt);
  DTtimestr:=maketimestr(dt.hour,dt.min,dt.sec);
end;

Function DTDateStr(time:longint):string12;
var dt:datetime;
begin
  unpacktime(time,dt);
  DTdatestr:=makeDatestr(dt.day,dt.month,dt.year);
end;

FUNCTION TimeOfDay : LONGINT;

VAR
   Hours   : WORD;
   Minutes : WORD;
   Seconds : WORD;
   SecHun  : WORD;

   TimeVal : LONGINT;

BEGIN

   GetTime( Hours, Minutes, Seconds, SecHun );

   TimeVal    := Hours;
   TimeOfDay  := TimeVal * 3600 + Minutes * 60 + Seconds;

END ;


FUNCTION TimeDiff( Timer1, Timer2: LONGINT ) : LONGINT;

CONST
   Secs_Per_Day = 86400    {* Seconds in one day *};

VAR
   TDiff : LONGINT;

BEGIN

   TDiff := Timer2 - Timer1;

   IF ( TDiff < 0 ) THEN
      TDiff := TDiff + Secs_Per_Day;

   TimeDiff := TDiff;

END ;

FUNCTION TimeOfDayH : LONGINT;

VAR
   Hours   : WORD;
   Minutes : WORD;
   Seconds : WORD;
   SecHun  : WORD;

   TimerVal: LONGINT;

BEGIN

   GetTime( Hours, Minutes, Seconds, SecHun );

   TimerVal    := Hours;
   TimeOfDayH  := TimerVal * 360000 + Minutes * 6000 + Seconds * 100 + SecHun;

END ;


FUNCTION TimeDiffH( Timer1, Timer2: LONGINT ) : LONGINT;

CONST
   Hundredths_Secs_Per_Day = 8640000    {* 1/100 Seconds in one day *};

VAR
   TDiff : LONGINT;

BEGIN

   TDiff := Timer2 - Timer1;

   IF Tdiff < 0 THEN Tdiff := Tdiff + Hundredths_Secs_Per_Day;

   TimeDiffH := Tdiff;

END ;

{$IFNDEF linux}
Procedure Cursor(Groesse:Byte);
Var Regs:Registers;

BEGIN
  If Groesse = 0 Then
    Regs.CX:=$2000
  Else
    If Groesse = 1 Then
      Regs.CX:=  10
    Else
      Regs.CX := 6 * 256 +7;
  Regs.AX := $100;
  Intr(16,Regs);
END;


PROCEDURE SelectBlock(a,b:byte);
var r:registers;
BEGIN
  r.ah := $10;
  r.al := $00;
  r.bl := $12;
  if a<> b then r.bh:=$7 else r.bh:=$f;
  intr($10,r);
  r.bl:= (a and 3) + (a and 4) shl 2 + (b and 3) shl 2 +  (b and 4) shl 4;
  r.ah:=$11;
  r.al:=3;
  intr($10,r);
end;

PROCEDURE setvmode(b:byte);
BEGIN
  if b=0 THEN TextMode(co80);
  if not (b in [1,2,4]) THEN exit;
  inc(b,$10);
  asm
    mov ah,$11
    mov al,b
    mov bl,1
    int 10h
    mov ah,$10
  end;
  selectblock(1,1);
END;


{Schreib das mit 'Zeichen' angegebene Zeichen 'Anz' mal
 (Entspricht STRING$ aus Basic}
FUNCTION StringD(Zeichen: CHAR; Anz: WORD): STRING; Assembler;
ASM
  PUSH DS
  CLD                           {Lschen des Richtungsflags}
  LES DI,@Result                {Ergebnis der Funktion nach ES:[DI]}
  MOV CX,Anz                    {Anzahl nach CL}
  MOV ES:[DI],CL                {Anzahl als Byte 0 in den String}
  INC DI
  MOV AL,Zeichen                {Zeichen nach AL}
  REP STOSB                     {Zeichen Anz mal in den Ergebnisstring
                                 schreiben}
  POP DS
END;
{$ENDIF}
{$IFDEF linux}

FUNCTION STRINGD(Zeichen: CHAR; anz: WORD):STRING;
VAR S : STRING;
   b  :  BYTE;
   
BEGIN
   for b:= 1 to anz DO s[b]:=zeichen;  
   byte(s[0]):=anz;
   stringd:=s;
END; { STRINGD }

{$ENDIF}



FUNCTION OnlyOneSpace(S: STRING): STRING;
VAR i: INTEGER;
    Anz: BYTE;
BEGIN
  Anz := 0;
  FOR i := LENGTH(S) DOWNTO 1 DO BEGIN
    IF S[i]=' ' THEN BEGIN
      Anz := Anz + 1;
      IF Anz=2 THEN BEGIN
        DELETE(S,i,1);
        Anz := Anz - 1;
      END;
    END
    ELSE Anz := 0;
  END;
  OnlyOneSpace := S;
END;
{
FUNCTION FileDa(s:pathstr):BOOLEAN;
VAR SR:SearchRec;
BEGIN
  FileDa:=FALSE;
  FindFirst(s,anyfile,sr);
  IF (doserror=0) AND ((sr.attr AND directory+volumeID)=0)
    THEN FileDa:=TRUE;
END;
}
FUNCTION FileDa(S: PathSTR): BOOLEAN;
VAR f: File;
BEGIN
  ASSIGN(f,S);
  {$I-}
  RESET(f,1);
  {$I+}
  IF IOResult=0 THEN BEGIN
    CLOSE(f);
    FileDa := TRUE;
  END
  ELSE FileDa := FALSE;
END;

FUNCTION mkTStr(ti:longint):STRING12;
VAR s:STRING[10];
BEGIN
  S:='';
  IF ti<100 THEN
  BEGIN
    {$IFDEF linux}
    str(ti,s);
    while length(s)<3 do s:=s+' ';
    {$ELSE}
    str(ti:3,s);
    {$ENDIF}
    s:=s +'s';
  END ELSE
    IF (Round(ti DIV 60)<100) THEN
    BEGIN
      {$IFDEF linux}
      str(round(ti DIV 60),s);
      while length(s)<3 do s:=s+' ';
      {$ELSE}
      str(round(ti DIV 60):3,s);
      {$ENDIF}
      s:=s+'m';
    END ELSE
      IF (Round(ti DIV 3600)<100) THEN
      BEGIN
        {$IFDEF linux}
        str(round(ti DIV 3600),s);
        while length(s)<3 do s:=s+' ';
        {$ELSE}
        str(round(ti/3600):3,s);
        {$ENDIF}
        s:=s+'h';
      END ELSE
      BEGIN
        {$IFDEF linux}
        str(round(ti DIV 86400),s);
        while length(s)<3 do s:=s+' ';
        {$ELSE}
        str(round(ti/86400):3,s);
        {$ENDIF}
        s:=s+'d';
      END;
  MkTstr:=S;
END;

{$IFNDEF linux}
PROCEDURE XGotoXY(X,Y:BYTE);ASSEMBLER;
   ASM
     MOV ah,2
     MOV bh,0
     MOV dl,X
     MOV dh,Y
     DEC dl
     DEC dh
     INT $10
END;
{$ELSE}
PROCEDURE XGotoXY(X,Y : BYTE);
BEGIN
   CRT.GotoXY(x,y);
END; { XGotoXY }
{$ENDIF}
    
{$IFNDEF linux}
{* Dies ist die DL5FBD-Gedaechnis-Routine ... *}
PROCEDURE MakeFNClean(VAR S:STRING);
VAR S2,L,R:STRING;Handle:WORD;B:BYTE;
BEGIN
  WHILE FIND(S,':',l,r) DO S:=r;
  WHILE FIND(S,'\',l,r) DO S:=r;
  WHILE FIND(S,'/',l,r) DO S:=r;
  S2:='';
  FOR B:=1 TO LENGTH(S) DO
  IF (S[B]>#32) AND NOT (S[B] IN ['\','/','?','*',#255,#39,'|','<','>']) THEN
    S2:=s2+s[b];
  S2:=GROSS(s2);
  IF (S2='CLOCK$') OR
     ((COPY(S2,1,3)='LPT') AND (S2[4] IN ['0'..'9']) AND (S2[0]=#4)) OR
     ((COPY(S2,1,3)='COM') AND (S2[4] IN ['0'..'9']) AND (S2[0]=#4)) OR
     (S2='AUX') OR
     (S2='CON') OR
     (S2='PRN') OR
     (S2='NUL') THEN
    S2:=xhex(currixtime);
  {* soo, nu um ganz sicher zu gehen, gucken wir, ob sich der uebergebene
     dateiname im verzeichnis /dev/ oeffnen laesst' *}
  R:=s2+#0;
  S:=s2;
END;
{$ELSE}

PROCEDURE MakeFNClean(VAR S:STRING);
VAR L,R,S2 : STRING;
   B	   : BYTE;
BEGIN
   WHILE POS('\',S)>0 DO S:=COPY(S,POS('\',S)+1,255);
   WHILE POS('/',S)>0 DO S:=COPY(S,POS('/',S)+1,255);
      {
  WHILE FIND(S,':',l,r) DO S:=r;
  WHILE FIND(S,'\',l,r) DO S:=r;
  WHILE FIND(S,'/',l,r) DO S:=r;
  S2:='';
  FOR B:=1 TO LENGTH(S) DO
  IF (S[B]>#32) AND NOT (S[B] IN ['\','/','?','*',#255,#39,'|','<','>']) THEN
    S2:=s2+s[b];
   S:=s2;}

END; { MakeFNClean }
{$ENDIF}
   
FUNCTION FilterCRLF(S:STRING):STRING;
BEGIN
   WHILE POS(#10,S)>0 DO DELETE(S,POS(#10,S),1);
  WHILE POS(#13,S)>0 DO DELETE(S,POS(#13,S),1);
  FilterCRLF:=S;
END;  
{$IFDEF linux}
PROCEDURE VAL(S:STRING;VAR W:BYTE;VAR err:INTEGER);
VAR lo:LONGINT;er:WORD
BEGIN
  system.val(s,lo,er);
  err:=er;w:=lo;
END;  

PROCEDURE VAL(S:STRING;VAR W:WORD;VAR err:INTEGER);
VAR lo:LONGINT;er:WORD
BEGIN
  system.val(s,lo,er);
  err:=er;w:=lo;
END;  
PROCEDURE VAL(S:STRING;VAR W:LONGINT;VAR err:INTEGER);
VAR lo:LONGINT;er:WORD
BEGIN
  system.val(s,lo,er);
  err:=er;w:=lo;
END;  
PROCEDURE VAL(S:STRING;VAR W:INTEGER;VAR err:INTEGER);
VAR lo:LONGINT;er:WORD
BEGIN
  system.val(s,lo,er);
  err:=er;w:=lo;
END; 

FUNCTION CheckCall(s:STRING):BOOLEAN;
BEGIN
  CheckCall:=TRUE;
END;  
FUNCTION ConvertByteToString(b:byte):STRING;
VAR S:STRING;W:WORD;L:LONGINT;
BEGIN
  str(b,s);
  ConvertByteToString:=S;
END;  

FUNCTION JoinStr(s1,s2:STRING):STRING;
BEGIN
   JoinStr:=s1+s2;
END;   

FUNCTION AddCHAR(s1:STRING;C:CHAR):STRING;
BEGIN
  AddCHAR:=S1+c;
END;  

{$ENDIF}

FUNCTION ConvertHexStringToWord(S : STRING;VAR W:WORD):BOOLEAN;
VAR err	: WORD;b:WORD;
BEGIN
  (* VAL('$'+S,W,err);
   ConvertHexStringToWord:=(err=0);*)
   {$R-}
   ConvertHexStringToWord:=TRUE;
   s:=gross(s);
   B:=LENGTH(S);
   W:=0;
  
   while b>0 DO
   BEGIN
     IF (S[B] >= '0') AND (S[b] <= '9') THEN
	W:=W+(ord(S[b])-48) SHL ((length(s)-b)*4)
     ELSE IF (S[B] >= 'A') AND (S[B]<= 'F') THEN
	W:=W+(ord(s[B])-55) SHL ((length(S)-b)*4)
     ELSE
     BEGIN
	ConvertHexStringtoWord:=FALSE;
	exit;
     END;
     dec(b);
   END;	         
END;   
BEGIN
{$IFNDEF linux}
Windowcount:=0;
{$ENDIF}
CurrIXTime;

END.









